#include "Api/OsaDef.h"
#include "OsaRtl.h"
#include "OsaMemory.h"

static int OSA_CDECL __default_nh(size_t);

/******************************************************************************
  @data
  Global pointer to the global new handler. For the new function to use
******************************************************************************/
_PNH __newhandler = __default_nh;


/******************************************************************************
  @func
  The default new handler, under DBG: prints a message and breakpoints.
  otherwise does nothing.
******************************************************************************/
static int OSA_CDECL __default_nh(size_t)
{
  OSA_EPRINTF(("Osa: __default_nh: out of memory in operator new!\n"));
  OSA_BREAKPOINT();
  return 0;
};


/******************************************************************************
******************************************************************************/
_PNH OSA_CDECL _set_new_handler( _PNH pfnHandler )
{
  //ASSERT(NULL != pfnHandler);
  _PNH pfnOldhandler = __newhandler;
  __newhandler = pfnHandler;

  return pfnOldhandler;
}


